# H.-B. Woyand - Python fuer Ingenieure
# und Naturwissenschaftler - Kapitel 10
# Aufgabe 10.3 - Datei: Aufgabe_10_03.py
# fuer Python 3

from scipy.optimize import newton                       
import numpy as np                                                
import matplotlib.pyplot as plt                                

def f(x):                                                                         
    return np.cos(x-np.pi/5)-np.log(x)+1

x = np.linspace(2,8,60)                                            
y = f(x)                                                                          

plt.plot(x,y,'r-',linewidth=2)
plt.xlabel("x-Werte")                                               
plt.ylabel("y-Werte")                                               
plt.title("Nullstellen")                                           
plt.grid(True)                                                           

xa1 = 2.4
xa2 = 6.4
xa3 = 7.2

x1 = newton(f,xa1)                                                 
x2 = newton(f,xa2)                                                  
x3 = newton(f,xa3)

print("Die Nullstellen sind: ",x1,x2,x3)

nullstellen = np.array([x1,x2,x3])                
plt.scatter(nullstellen,[0,0,0],s=100)                  
plt.plot(x,y,'r-',linewidth=3)                                   
plt.grid(True)                                                     
plt.show()                                                              
