# H.-B. Woyand - Python fuer Ingenieure
# und Naturwissenschaftler - Kapitel 10
# Aufgabe 10.4 - Datei: Aufgabe_10_04.py
# fuer Python 3

from scipy.optimize import minimize                   
import numpy as np

def Z(u):                                                                   
    "Zielfunktion"
    x = u[0]
    y = u[1]
    return (x-5)**2+(y-8)**2

def N(u):                                                             
    "Nebenbedingung - Gleichung"
    x = u[0]
    y = u[1]
    return x*y-5

x0 = 3; y0 = 3
w0 = [x0, y0]
print("Zielfunktion (Anfangswert): ",Z(w0))
print("Nebenbedingung (Anfangswert): ",N(w0))
print()

g = (0.0, 10.0)                                                      
B = [g, g]                                                             
NebenBed = { 'type' : 'eq' , 'fun':N }
cons = [NebenBed]                                           

ergebnis = minimize(Z,w0,method='SLSQP',
                    bounds=B,constraints=cons)    
xq = ergebnis.x[0]
yq = ergebnis.x[1]
abstand = np.sqrt(ergebnis.fun)
print("Punkt Q: ",xq,",",yq)
print("Minimaler Abstand: ",abstand)


