# H.-B. Woyand - Python fuer Ingenieure
# und Naturwissenschaftler - Kapitel 10
# Aufgabe 10.5 - Datei: Aufgabe_10_05.py
# fuer Python 3

from scipy.fftpack import fft, ifft               
import numpy as np
import matplotlib.pylab as plt

n = 2**12
t_ende = 2*np.pi
dt = t_ende/n

def rechteck(t):
    y = 1.0
    if t>=np.pi:
        y=-1.0
    return y

y = [ ]
x = np.linspace(0.0,n*dt,n)
for i in x:
    y.append(rechteck(i))

u = fft(y)
v = 2.0/n*np.abs(u)
w = 2*np.pi*np.linspace(0.0,1.0/(2.0*dt), n//2)

z = []
for i in x:
    s = 0
    for j in range(1,10,2):
        s = s + 4/np.pi*np.sin(j*i)/j
    z.append(s)   


plt.plot(x,y,"b-",x,z,"r-",linewidth=3)
plt.grid()
plt.xlabel("x"); plt.ylabel("y")
plt.show()

plt.grid()
plt.xlabel("Kreisfrequenz w [1/sec]")
plt.ylabel("Frequenzspektrum u(w)")
plt.bar(w[:15],v[:15], color="blue",linewidth=3,align="center")
plt.show()

